This thread has been locked.

If you have a related question, please click the "Ask a related question" button in the top right corner. The newly created question will be automatically linked to this question.

AM6442: AM64x SDK - want to know if gadget tool (https://github.com/linux-usb-gadgets/gt/) can be cross compiled into a customized Arago distribution (and the SD card) on SG-AM64B

Part Number: AM6442

Tool/software:

Further followup on Linux USB gadgets from activity with Bin Lu, (aka (+) AM6442: While configuring A53 core foe use as a USB gadget, can one use the the libusbgx C coded API (https://github.com/linux-usb-gadgets/libusbgx) gadget schemes instead of using linux shell scripts - Processors forum - Processors - TI E2E support forums )

need some advice on some other open source USB gadget automation inclusion of modules (may need (+) Andreas Dannenberg's Profile - Andreas Dannenberg - TI E2E support forums advice with Yocto related dependences).

Found a gadget tool gt (https://github.com/linux-usb-gadgets/gt ) "Linux command line tool for setting USB gadget using configFS"

What I read on documented dependencies for gt: (per  https://github.com/linux-usb-gadgets/gt/tree/master/examples/cross-compile) for an arm platform, not compiled with gadgetd support

Questions:

On the gt cross compile file, they "assume that compilation is for armhf" - is that armhf need a show-stopper?

On that same gt cross compile file, they also call out use of cmake -- does that mean I need to install cmake alongside make as well?

  • Hi Jim,

    On the gt cross compile file, they "assume that compilation is for armhf" - is that armhf need a show-stopper?

    On that same gt cross compile file, they also call out use of cmake -- does that mean I need to install cmake alongside make as well?

    I am a kernel guy and barely touch Linux user space for quite a long time, so I am unable to quickly answer these questions. BTY, I believe "armhf" is a 32-bit toolchain, so if the package only supports armhf, the binary won't run on AM6442 which is 64-bit.

    Found a gadget tool gt (https://github.com/linux-usb-gadgets/gt ) "Linux command line tool for setting USB gadget using configFS"

    But I am wondering why you would need this tool, what does this tool do more than the sysfs interface of the USB gadget configfs?

    BTY, attached below is a bash script I wrote many years ago for using USB gadget configfs. I use it often in testing different gadget functions. For each test, I don't need to modify the script, the only change is its first line "FUNCS" variable which defines the USB gadget functions to be added into the composite gadget for my testing.

    usbconfigfs.sh

  • So Bin:

     would these gadget automation routines work on the AM243x 32-bit only product line given the armhf  restriction? If so, what about the cmake issue??

    Thanks for posting your script - quite useful

    Jim

  • Hi Jim,

    We are discussing Linux user space program, but Linux is not supported on AM243x. It is not relevant, right?

    Sorry, I don't know the answer about cmake. I only used it a few time to compile Linux packages, but never looked into how it works.

  • oops Bin - wishful thinking on my part (i.e. hoping R5 & M4 cores could be supported on a Linux OS - after Torvalds said the Linux 6.12 base is a true embedded rtos). thanks.

  • Bin:

     that script that you showed is good for the creation side of a USB composite gadget from a USB host perspective; do you have anything on the USB composite DEVICE side to share with us (like checking for configfs mounted directory structure from the device side?

    thanks

    Jim

  • Jim,

    That script is to run on AM64x to create USB device. It doesn't run on USB host.

    do you have anything on the USB composite DEVICE side to share with us (like checking for configfs mounted directory structure from the device side?

    I am not sure I understand the question. Please elaborate, what configfs dir structure do you want to check?

  • Bin:

    If I have the AM6442 configured as a USB composite gadget, I would like to verify on the embedded AM6442 USB device that the necessary directories in the Linux file system were created by that script,

    later

    Jim

  • Hi Jim,

    Since that script is only for myself, I was lazy to add any error check. But if any of the command in that script failed, the command return code ($?) would be non-zero and the Linux console would print an error message. So you could add the return code ($?) check for every command in the script, then you would know if the USB gadget has been created properly on AM6442.

    Just FYI, I have my own way to do such error check in bash script:

        shell_command_1 || exit 1
        shell_command_2 || exit 2
        ...
        echo done

    In this way if each shell command failed, the return code would be non-zero (1, 2, or any number in that corresponding "exit" command), the "echo done" command at the end will return 0.

    So I run my script, then check its return code. If it is 0, all good; If a number, I will check the script to see which line failed based on that number.

    Hope this answers your question.